*       Reassemblerroutine fr Atari-ST                          *
*          copyright Arno Kizina 1990                            *

* changed 1991: leichter an andere Prozessoren 680x0 anpassbar
* disassembler in  a0 :pc
*	       in  a1 :Zeiger auf buffer (128 Bytes)
*              out d0 :Anzahl Bytes fr Befehl
*              verndert: d0
*cprght:       dc.b    'by Arno Kizina 1990,1991,1998,1999'
	even
disass:         movem.l d1-d7/a0-a6,-(sp)

                moveq   #0,d0
                move.l  d0,d5
                move.w  (a0)+,d0
                moveq   #2,d6
                move.l  d0,d1
                lsr.w   #8,d1
                lsr.b   #4,d1   ;d1:art                
                move.l  d0,d3
                andi.l  #$fc0,d3
                lsr.w   #1,d3
                lsr.b   #5,d3
                move.b  d3,d5
                lsr.w   #8,d3
                swap    d3
                or.l    d3,d5   ;d5:highwd:reg op2,lowwd:modus op2 Bit 6-11

                move.l  d0,d4
                andi.w  #$3f,d4
                lsl.w   #5,d4
                lsl.l   #8,d4
                lsr.w   #8,d4
                lsr.b   #5,d4
                swap    d4      ;d4:reg op1,modus op1 for move op2,op1
                movea.l	a1,a5
                movea.l  a5,a4
                moveq   #31,d2
                moveq   #0,d7
disasslp:       move.l  d7,(a5)+
                dbf     d2,disasslp 	;buffer lschen               
                lea     disjmptab(pc),a5
                lsl.w   #1,d1               ;art*2
                adda.w  0(a5,d1.w),a5
                jsr     (a5)
                move.l  d6,d0
                movem.l (sp)+,d1-d7/a0-a6
                rts
                
disjmptab:      dc.w    dzero-disjmptab,done-disjmptab,dtwo-disjmptab
                dc.w    dthree-disjmptab,dfour-disjmptab,dfive-disjmptab
                dc.w    dsix-disjmptab,dseven-disjmptab,deight-disjmptab
                dc.w    dnine-disjmptab,dten-disjmptab,deleven-disjmptab
                dc.w    dtwelve-disjmptab,dthirteen-disjmptab
                dc.w    dfourteen-disjmptab,dfifteen-disjmptab                

_get_word:      moveq   #0,d1
_get_word1:     addq.w  #2,d6
                move.w  (a0)+,d1
                rts
                
_bit6_7bwl:     move.w  d0,d7
                lsr.w   #6,d7
                andi.l  #3,d7
_wl_1:          rts
_bit6_wl:       moveq   #1,d7
                btst    #6,d0
_entry_wl:      beq.b   _wl_2
                addq.w  #1,d7
_wl_2:          bra.b   _wl_1
_bit8_wl:       moveq   #1,d7
                btst    #8,d0
                bra.b   _entry_wl

_hexsbyte:	ext.w	d1
_hexsword:	ext.l	d1
		tst.l	d1
		bpl.b	_hexlong
		move.b	#'-',(a4)+
		neg.l	d1
		bra.b	_hexlong                
_hexbyte:	andi.b	#$ff,d1
_hexword:	andi.w	#$ffff,d1
_hexlong:       movem.l d0/d2/a1,-(sp)
	        move.b  #'$',(a4)+
                lea     _hexdig(pc),a1
                moveq   #0,d0                
                swap    d1
                bsr.b   hexw
                swap    d1
                bsr.b   hexw
                tst.w   d0
                bne.b   _hexiswr
                move.b  #'0',(a4)+
_hexiswr:       movem.l (sp)+,d0/d2/a1
                rts
hexw:           ror.w   #8,d1
                bsr.b   hexb
                ror.w   #8,d1
hexb:           ror.b   #4,d1
                bsr.b   hexn                
                ror.b   #4,d1
hexn:           move.w  d1,d2
                andi.w  #$f,d2
                cmpi.b  #0,d2
                bne.b   _hexwr
                tst.w   d0
                beq.b   _hexnwr
_hexwr:         moveq   #1,d0
                move.b  0(a1,d2.w),(a4)+
_hexnwr:        rts  
_hexdig:        dc.b    '0123456789abcdef'

        even
*hole codierten operanden in:a1,a0 so;d2.l reg,modus
*                            d7.w 0=b,1=w,2=l
_get_operand:   moveq.l #0,d3
                move.w  d2,d3   ;d3:Registernummer
                swap    d2      ;d2:Modus
                exg     d2,d3
                andi.l  #$ff,d3
                cmpi.w  #0,d2   ;dn?
                
                bne.b   _not_dn
_get_entry1:    moveq   #1,d2
_get_entry:     lea     regist1(pc),a5
                cmpi.b  #17,d3
                bls.b   _get_ok
                addq    #1,d2
_get_ok:        lsl.w   #2,d3
                adda.w  d3,a5
_get_lp:        move.b  (a5)+,(a4)+
                dbeq    d2,_get_lp                
                rts
                

_not_dn:        cmpi.w  #1,d2   ;an?

                bne.b   _not_an
_is_an:         bchg    #3,d3
                bra.b   _get_entry1
                
_not_an:        cmpi.w  #2,d2   ;(an)?

                bne.b   _not_an1
_is_an1:        move.b  #'(',(a4)+
                bsr.b   _is_an
                move.b  #')',(a4)+
                rts

_not_an1:       cmpi.w  #3,d2   ;(an)+?

                bne.b   _not_an2
                bsr.b   _is_an1
                move.b  #'+',(a4)+
                rts
                
_not_an2:       cmpi.w  #4,d2   ;-(an)?

                bne.b   _not_an3
                move.b  #'-',(a4)+
                bra.b   _is_an1

_not_an3:       cmpi.w  #5,d2   ;d(an)?

                bne.b   _not_an4
_dist_pc:       bsr     _get_word
                bsr     _isitlabel
                bcs     _is_an2
                bsr     _hexsword
_is_an2:        bra.b   _is_an1

_not_an4:       cmpi.w  #6,d2   ;d(an,rn.x)?
                bne.b   _not_an5
_dist_pc1:      bsr     _get_word
                move.w  d1,-(sp)
                andi.l  #$ff,d1
                bsr     _isitlabel
                bcs.b   _dist_yes
                bsr     _hexsbyte
_dist_yes:      bsr.b   _is_an2
                move.b  #',',-(a4)
                adda.l  #1,a4
                moveq   #1,d3
                move.w  (sp)+,d2                
                lsr.w   #8,d2
                lsr.b   #4,d2
                bcc.b   _dist_is_wd
                addq.b  #2,d3
_dist_is_wd:    exg     d2,d3
                move.w  d2,-(a7)
                bsr     _get_entry
                move.w  (a7)+,d2
                cmp.w   #3,d2
                beq     _not_wd_dst
                move.b  #'.',(a4)+
                move.b  #'w',(a4)+
_not_wd_dst:    move.b  #')',(a4)+
                rts
                
_not_an5:       cmpi.w  #2,d3   ;d(pc)?
                
                bne.b   _not_pc
                moveq   #24,d3
                bra.b   _dist_pc

_not_pc:        cmpi.w  #3,d3   ;d(pc,rn.x)?

                bne.b   _not_pc1
                moveq   #24,d3
                bra.b   _dist_pc1
                
_not_pc1:       cmpi.w  #0,d3   ;$xxxx?

                bne.b   _not_word
_entry_b:       bsr     _get_word
_do_word:       bsr     _isitlabel
                bcs.b   _itislabel
                bra     _hexword
                
_not_word:      cmpi.w  #1,d3   ;$xxxxxxxx?

                bne.b   _not_long
_in_long:       bsr     _get_word
                bsr     _isitlabel
                bcs.b   _itislabel
                swap    d1
                bsr     _get_word1
                bsr     _hexlong
_itislabel:     rts                

_not_long:      cmpi.w  #4,d3

                bne     _whatthat
_in_word:       move.b  #'#',(a4)+
                cmpi.w  #0,d7
                
                beq.b   _entry_b
                
_no_byte:       cmpi.w  #1,d7
                beq.b   _entry_b
                
_no_word:       cmpi.w  #2,d7

                bne.b   _whatthat
                bra.b   _in_long
_whatthat:      moveq   #65,d1          ;neu:??? bei unbekanntem Operanden
                bra     copytext
                bra     dfifteen
_isitlabel:     andi.b    #$fe,ccr
                rts  
*Kopierroutinen :in d1 Textnummer,d7 Lnge 0=.b, a4 Pointer in String
copytlen:       bsr     copytext
addlength:      lea     oplength(pc),a5
                move.l  d7,d1
                mulu    #3,d1
copyent1:       moveq   #2,d2
copyent:        adda.l  d1,a5
copyloop:       move.b  (a5)+,(a4)+
                dbeq    d2,copyloop
                bne.b   copynomin
                subq.w  #1,a4
copynomin:      rts
copytext:       andi.b  #$ff,d1
                lea     optexte(pc),a5
                moveq   #6,d2
                mulu    #7,d1
                bra.b   copyent
copycond:       lea     conditi(pc),a5
                lsl     #1,d1
                moveq   #1,d2
                bra.b   copyent
copyrot:        lea     rotat(pc),a5
                mulu    #3,d1
                bra.b   copyent1
dgetcond:       move.l  d0,d1
                lsr     #8,d1
                andi.b  #$f,d1
                rts                                                                                   

regist1: dc.b  'd0.l','d1.l','d2.l','d3.l','d4.l','d5.l','d6.l','d7.l'
        dc.b  'a0.l','a1.l','a2.l','a3.l','a4.l','a5.l','a6.l','a7.l'
        dc.b  'pc',0,0,'sr',0,0,'ccr',0,'usp',0,'ssp',0
        
        even
dten:
dfifteen:       moveq   #1,d1
entryfift:      bsr     copytext
                exg     d0,d1
                bra     _hexword
dseven:         btst    #8,d0           ;moveq
                bne.b   dfifteen
                moveq   #3,d1
                bsr     copytext
                move.b  d0,d1
                move.b  #'#',(a4)+
                bsr     _hexbyte
                move.b  #',',(a4)+
                swap    d5
                move.w  d5,d3
                bra     _get_entry1
                
done:           moveq   #0,d7           ;.b
domove:         moveq   #4,d1           ;move
bothops1:       bsr     copytlen        ;Text.x d4,d5
bothops:        move.l  d4,d2           ;beide Operanden
                bsr.b   _dogetoperand
                move.b  #',',(a4)+
oneop:          move.l  d5,d2
_dogetoperand:  bra     _get_operand 
               
dtwo:           moveq   #2,d7           ;.l
dtwoent:        moveq   #4,d1           ;move
                cmpi.b  #1,d4           ;movea?
                bne.b   dtwonotmovea
                addq    #1,d1           ;ja
dtwonotmovea:   bra.b   bothops1                
dthree:         moveq   #1,d7
                bra.b   dtwoent

dfour:          cmpi.b  #6,d5           ;chk?
                bne.b   dnotchk
dentrychk:      move.b  d5,d1           ;chk,lea
                andi.b  #1,d5
dnochange:      exg     d5,d4           ;Text d5,d4
dchange:        bsr     copytext        ;Text d4,d5
		exg	d4,d5
                bra.b   bothops
dnotchk:        cmpi.b  #7,d5           ;lea?
                beq.b   dentrychk
dnotlea:        move.w	d0,d1	        ;rts,nop,...
		andi.w	#$e70,d1
		cmpi.w	#$e70,d1
                bne.b   dnotrts
                cmpi.b	#1,d5
                bne.b	dnotrts
                swap    d4
                move.w  d4,d1
                addi.b  #8,d1
                bsr     copytext
                move.b  #1,d7
                cmpi.b  #2,d4           ;stop?
                beq     _in_word
                rts
dnotrts:        swap    d5              ;jmp,link,move usp...
                cmpi.b  #7,d5
                bne     dnotjmp
                swap    d5
                btst    #1,d5           ;3=11,2=10
                beq.b   dnojump
                moveq   #14,d1          ;jmp,jsr
                moveq   #2,d7
                add.b   d5,d1
ddooptext:      bsr     copytext
                bra     ddooneop
dnojump:        move.l  d4,d1           ;link,unlk,moveusp,trap
                cmpi.b  #2,d1
                bcs.b   distrap
                cmpi.b  #5,d1
                bhi     dfifteen
                move.b  #1,d4           ;an erzeugen
                cmpi.b  #3,d1                                
                bhi.b   dmoveusp
                add.b   #16,d1
                cmpi.b	#18,d1
                bne	ddooptext
                bsr	ddooptext
                move.b	#',',(a4)+
                move.b	#'#',(a4)+
                bsr	_get_word	;link,operand2
                bra	_hexsword
dmoveusp:       move.l  #$1b0001,d5     ;usp
		moveq	#2,d7
                cmpi.b  #4,d1
                beq     bothops1
                bra     bothops3
distrap:        moveq   #20,d1
                andi.w  #$f,d0                
                bra     entryfift
dnotjmp:        cmpi.b  #5,d5           ;illegal,tas,tst
                bne.b    dnotillegal
                moveq   #21,d1
                cmpi.l  #$10007,d4        ;.b        #7,d4
                beq     copytext        ;illegal
                swap    d5
                cmpi.b  #3,d5
                bhi     dfifteen
                beq.b   distas
                moveq   #23,d1          ;tst
doneoplen:      bsr     _bit6_7bwl
doneoplen1:     bsr     copytlen
ddooneop:	exg	d5,d4		;text  d4
                bra     oneop
distas:         moveq   #22,d1
                bra     ddooptext
dnotillegal:    cmpi.b  #3,d5           ;neg,clr,not,movesrccr
                bhi.b   dispea              
                swap    d5
                cmpi.b  #3,d5
                beq.b   dismovccr
                swap    d5
                moveq   #24,d1          ;negx,clr,neq,not
                add.b   d5,d1
                bra.b   doneoplen
dismovccr:      moveq	#4,d1
		swap    d5
                cmpi.b  #2,d5
                bne.b   dnotccr
                move.l  #$1a0001,d5     ;ccr
                moveq   #0,d7
dmovent:        bra	bothops1
dnotccr:        moveq   #1,d7
                move.b  d5,d3
                move.l  #$190001,d5     ;sr
                cmpi.b  #3,d3
                beq.b   dmovent
                cmpi.b	#0,d3
                bne     dfifteen
                bra	bothops3
dispea:         swap    d5
                cmpi.b  #0,d5           ;nbcd?
                bne.b   dnotnbcd
                moveq   #28,d1
                bra     ddooptext
dnotnbcd:       cmpi.b  #1,d5           ;swap,pea
                bne.b   dmovemext                                
                moveq   #29,d1
                cmpi.b  #0,d4
                beq.b   dnotbcdisswap
                addq.b  #1,d1
dnotbcdisswap:  bra     ddooptext
dmovemext:      bsr     _bit6_wl
                cmpi.b  #0,d4
                bne.b   dismovem
                moveq   #31,d1          ;ext
                bra     doneoplen1
dismovem:       moveq   #32,d1          ;movem
                bsr     copytlen
                bsr     _get_word
                move.l  d4,d2
                swap    d5
                cmpi.b  #6,d5
                beq.b   dregslast
                move.w	d1,d3
                cmpi.b	#4,d2
                bne.b	domovemregs
                moveq   #15,d5
dismovemlp:     lsr.w   #1,d3
                roxl.w  #1,d1
                dbf     d5,dismovemlp
domovemregs:    bsr     dmovemregs      ;bit0=d0,bit15=a7
                move.b	#',',(a4)+
                bra     _get_operand
dregslast:      move.w	d1,-(sp)
		bsr     _get_operand
		move.b	#',',(a4)+
		move.w	(sp)+,d1
dmovemregs:     movem.l d0-d4,-(sp)
                move.b  #'g',d2
                moveq   #1,d0
mdfloop:        subq.b  #3,d2
                swap    d0
                move.w  #7,d0
                moveq   #0,d4
mdloop:         roxr.w  #1,d1
                bcc.b   mdfnotset
mdfset:         cmpi.b  #0,d4
                beq.b   mdstartw
                addq.b  #1,d4
                cmpi.b  #'7',d4
                bne.b   mddoloop
mdwrall:        move.w  d4,d3
                moveq   #0,d4
                suba.w  #1,a4
                move.b  #'-',(a4)+
mdwrite:        move.b  d2,(a4)+
                move.b  d3,(a4)+
                move.b  #'/',(a4)+
                cmpi.b  #'7',d3
                beq.b   mddofloop
mddoloop:       dbf     d0,mdloop
mddofloop:      cmpi.b	#'a',d2
		beq.b	mdexit
		swap    d0
                dbf     d0,mdfloop
mdexit:         move.b  #0,-(a4)
                movem.l (sp)+,d0-d4
                rts
mdfnotset:      cmpi.b  #0,d4
                beq.b   mddoloop
                cmp.b   d3,d4
                bne.b   mdwrall
                moveq   #0,d4
                bra.b   mddoloop
mdstartw:       moveq   #7,d3
                sub.b   d0,d3
                add.b  #'0',d3
                move.w  d3,d4
                bra.b   mdwrite
                
dzero:          cmpi.b  #1,d4           ;movep?
                bne.b   dnotmovp
                btst    #8,d0
                beq     dfifteen
                moveq   #33,d1
                bsr     _bit6_wl
                move.b  #0,d5           ;dn
                move.b  #5,d4           ;d(an)
                btst    #7,d0
                beq     bothops1
bothops3:       exg     d5,d4           ; Text.x  d5,d4
                bra     bothops1
dnotmovp:       btst	#2,d5
                bne.b	disbits
                swap	d5
                cmpi.b  #4,d5
                beq.b   disbits1
                moveq   #34,d1          ;ori,andi,subi...
                add.b  d5,d1
                bsr     _bit6_7bwl
                move.l  #$40007,d5
                cmpi.l  #$40007,d4
                bne.b   dnotwithsr
                moveq   #$11,d4
                cmpi.b  #1,d7
                beq.b   dntmpnotsr
                addq.b  #1,d4
dntmpnotsr:     swap    d4
dnotwithsr:     bra     bothops3
disbits1:	swap	d5
disbits:        move.b  d5,d1          ;btst,bset...
		bclr	#2,d1
                add.b   #41,d1
                moveq   #1,d7
                btst    #2,d5
                beq.b   disimmed
                move.b  #0,d5
dnochange1:     bra     dchange
disimmed:       move.l  #$40007,d5
                bra.b   dnochange1
                
deleven:        move.b  d5,d1
                andi.b  #3,d1
                cmpi.b  #3,d1
                bne.b   dnotcmpa
                moveq   #46,d1          ;cmpa
                bsr     _bit8_wl
                move.b  #1,d5
dtobothops1:    bra     bothops1
dnotcmpa:       bsr     _bit6_7bwl
                cmpi.b  #1,d4
                bne.b   dnotcmpm
                moveq   #47,d1          ;cmpm
                move.b  #3,d4
                move.b  #3,d5
                bra.b   dtobothops1
dnotcmpm:       btst    #2,d5
                bne.b   diseor
                moveq   #45,d1          ;cmp
                move.b  #0,d5
                bra.b   dtobothops1
diseor:         moveq   #38,d1          ;eor
                move.b  #0,d5
                bra     bothops3
                                                                
dtwelve:        move.b  d5,d1
                andi.b  #3,d1
                cmpi.b  #3,d1
                bne.b   dnotmul
                moveq   #49,d1          ;mulu,muls
dtwelve1:       btst    #2,d5
                bne.b   dtwenotmuls
                subq.b  #1,d1
dtwenotmuls:    move.w  #0,d5
dchange1:       bra     dnochange
dnotmul:        move.w  d0,d1
                andi.w  #$1f0,d1
                cmp.w   #$100,d1
                bne.b   dnotabcd
                moveq   #50,d1          ;abcd
dtwelve4:       bsr.b	dtwelve2
	        bra.b   dchange1
dnotabcd:       btst    #2,d5
                bne.b   disexg
disand:         moveq   #55,d1          ;and
dtwelve3:       bsr     _bit6_7bwl
                btst    #2,d5
                bne.b   dtw3ddnop
                move.b  #0,d5
                bra     bothops1
dtw3ddnop:      move.b  #0,d5
                bra     bothops3
disexg:         cmpi.b  #1,d4
                bhi.b   disand
                and.b   d4,d5
                moveq   #51,d1
                bra	dchange
dtwelve2:	move.b	d4,d2
		move.b	#4,d5
		move.b	#4,d4
		cmpi.b	#1,d2
		beq.b	dtw2dabcd
		subq.b	#4,d4
		subq.b	#4,d5
dtw2dabcd:	rts		                                      
deight:         move.b  d5,d1
                andi.b  #3,d1
                cmpi.b  #3,d1
                bne.b   dnotdiv
                moveq   #53,d1          ;divu
                bra     dtwelve1
dnotdiv:        move.w  d0,d1
                andi.w  #$1f0,d1
                cmpi.w  #$100,d1
                bne.b   dnotsbcd
                moveq   #54,d1          ;sbcd
                bra     dtwelve4
dnotsbcd:       moveq   #56,d1          ;or
                bra     dtwelve3

dnine:          moveq   #57,d1
                bra.b   dningoon
                
dthirteen:      moveq   #60,d1
dningoon:       move.b  d5,d3
                andi.b  #3,d3
                cmpi.b  #3,d3
                bne.b   dnotsuba
                bsr     _bit8_wl        ;adda,suba
                addq.b  #2,d1
                move.b  #1,d5
dttobothop3:    bra     bothops1
dnotsuba:       bsr     _bit6_7bwl
		btst	#2,d5
		bne.b	dissubx
dissub:		move.b	d5,d3
		move.b	#0,d5		
                btst    #2,d3
                beq.b	dttobothop3
                bra	bothops3
dissubx:        cmpi.b	#2,d4
		bcc.b	dissub
		addq.b  #1,d1           ;addx,subx
                bsr     dtwelve2
                bra.b	dttobothop3
                
dsix:           bsr     dgetcond
                move.b  #'b',(a4)+
                cmpi.b  #0,d1
                bne.b   dsixnotbra
                move.b  #'r',(a4)+
                move.b  #'a',(a4)+
                bra.b   dsix1
dsixnotbra:     cmpi.b  #1,d1
                bne.b   dsixnotbsr
                move.b  #'s',(a4)+
                move.b  #'r',(a4)+
                bra.b   dsix1
dsixnotbsr:     bsr     copycond
dsix1:          tst.b   d0
                beq.b   dsixisword
                move.b  #3,d7
                bsr     addlength
                move.b  d0,d2
                andi.l  #$ff,d2
                ext.w   d2
dsixe1:         ext.l   d2
                move.l  a0,d1
                add.l   d2,d1
                bra     _do_word
dsixisword:     move.b	#9,(a4)+
dsixisword1:	bsr     _get_word
                sub.w   #2,d1
                move.w  d1,d2
                bra.b   dsixe1
                                                                 
dfive:          move.b  d5,d1
                andi.b  #3,d1
                cmpi.b  #3,d1
                bcs.b   disaddsub
                bsr     dgetcond
                cmpi.b  #1,d4
                beq.b   disdbcc
                move.b  #'s',(a4)+            ;  scc
                bsr     copycond
                move.b  #9,(a4)+
                bra     ddooneop
disdbcc:        move.b  #'d',(a4)+            ;  dbcc
                move.b  #'b',(a4)+
                bsr     copycond
                move.b  #9,(a4)+
                move.b  #0,d4
                bsr     ddooneop
                move.b  #',',(a4)+
                bra.b   dsixisword1
disaddsub:      bsr     _bit6_7bwl
                moveq   #63,d1                  ;addq,subq
                btst    #2,d5
                beq.b   disaddq
                addq.b  #1,d1                   ;fr subq
disaddq:        bsr     copytlen
                bsr     dgetcopnr
                bra.b   dgooneop
dgetcopnr:      move.b  #'#',(a4)+
                swap    d5
                cmpi.b  #0,d5
                bne.b   dgetcopnr1
                move.b  #8,d5
dgetcopnr1:     addi.b  #'0',d5
                move.b  d5,(a4)+
                move.b  #',',(a4)+
                rts
                                                                                                
dfourteen:      move.b  d5,d1
                andi.b  #3,d1
                cmpi.b  #3,d1
                bne.b   dfoutndn
                swap    d5
                move.b  d5,d1
                bsr     copyrot
                swap    d5
                bsr     dadddir
                move.b  #9,(a4)+
dgooneop:       bra     ddooneop
dfoutndn:       bsr     _bit6_7bwl
                move.b  d4,d1
                andi.b  #3,d1
                bsr     copyrot
                bsr     dadddir
                bsr     addlength
                btst    #2,d4
                beq.b   dfouwc
                move.b  #'d',(a4)+
                swap	d5
                bsr     dgetcopnr1
                bra     dgetfiop
dfouwc:         bsr     dgetcopnr
dgetfiop:       move.b  #0,d4
                bra.b   dgooneop                                
dadddir:        btst    #2,d5
                bne.b   disleft
                move.b  #'r',(a4)+
                rts
disleft:        move.b  #'l',(a4)+
                rts             

optexte: dc.b  'dc.b',9,0,0   	;0
         dc.b  'dc.w',9,0,0   	;1
         dc.b  'dc.l',9,0,0   	;2
         dc.b  'moveq',9,0    	;3
         dc.b  'move',0,0,0  	;4
         dc.b  'movea',0,0   	;5
         dc.b  'chk',9,0,0,0  	;6
         dc.b  'lea',9,0,0,0  	;7
         dc.b  'reset',0,0   	;8
         dc.b  'nop',0,0,0,0 	;9
         dc.b  'stop',9,0,0   	;10
         dc.b  'rte',0,0,0,0 	;11
         dc.b  'rtd',0,0,0,0 	;12
         dc.b  'rts',0,0,0,0 	;13
         dc.b  'trapv',0,0   	;14
         dc.b  'rtr',0,0,0,0 	;15
         dc.b  'jsr',9,0,0,0  	;16
         dc.b  'jmp',9,0,0,0  	;17
         dc.b  'link',9,0,0   	;18
         dc.b  'unlk',9,0,0   	;19
         dc.b  'trap',9,'#',0   ;20
         dc.b  'illegal'     	;21
         dc.b  'tas',9,0,0,0  	;22
         dc.b  'tst',0,0,0,0   	;23
         dc.b  'negx',0,0,0  	;24
         dc.b  'clr',0,0,0,0 	;25
         dc.b  'neg',0,0,0,0 	;26
         dc.b  'not',0,0,0,0 	;27
         dc.b  'nbcd',9,0,0   	;28
         dc.b  'swap',9,0,0   	;29
         dc.b  'pea',9,0,0,0  	;30
         dc.b  'ext',0,0,0,0  	;31
         dc.b  'movem',0,0   	;32
         dc.b  'movep',0,0   	;33
         dc.b  'ori',0,0,0,0 	;34
         dc.b  'andi',0,0,0  	;35
         dc.b  'subi',0,0,0  	;36
         dc.b  'addi',0,0,0  	;37
         dc.b  'eor',0,0,0,0 	;38
         dc.b  'eori',0,0,0  	;39
         dc.b  'cmpi',0,0,0  	;40
         dc.b  'btst',9,0,0   	;41
         dc.b  'bchg',9,0,0   	;42
         dc.b  'bclr',9,0,0   	;43
         dc.b  'bset',9,0,0   	;44
         dc.b  'cmp',0,0,0,0 	;45
         dc.b  'cmpa',0,0,0  	;46
         dc.b  'cmpm',0,0,0  	;47
         dc.b  'mulu',9,0,0 	;48
         dc.b  'muls',9,0,0     ;49
         dc.b  'abcd',9,0,0     ;50
         dc.b  'exg',9,0,0,0    ;51
         dc.b  'divu',9,0,0     ;52
         dc.b  'divs',9,0,0     ;53
         dc.b  'sbcd',9,0,0     ;54
         dc.b  'and',0,0,0,0    ;55
         dc.b  'or',0,0,0,0,0   ;56
         dc.b  'sub',0,0,0,0    ;57
         dc.b  'subx',0,0,0     ;58
         dc.b  'suba',0,0,0     ;59
         dc.b  'add',0,0,0,0    ;60
         dc.b  'addx',0,0,0     ;61
         dc.b  'adda',0,0,0     ;62
         dc.b  'addq',0,0,0     ;63
         dc.b  'subq',0,0,0     ;64
         dc.b  '???',0,0,0,0    ;65
rotat:   dc.b  'as',0,'ls',0,'rox','ro',0

conditi: dc.b  't',0,'f',0,'hi','ls'		; 0-15
        dc.b  'cc','cs','ne','eq','vc'
        dc.b  'vs','pl','mi','ge','lt'
        dc.b  'gt','le'

oplength: dc.b '.b',9,'.w',9,'.l',9,'.s',9	;0-3
	even
